class
	APPLICATION

inherit
	SHARED_X



create
	make

feature {NONE} -- Initialization

	make
		do
--			test_sharing
--			test_double
--			test_recursive
--			test_gc
		end


feature -- Sharing example

	test_sharing
		local
			a: A
			b: B
			c: C
		do
			create a
			create b
			create c
			print_line (global_x.value) -- ?
			a.global_x.increase
			print_line (global_x.value) -- ?
			b.global_x.increase
			print_line (global_x.value) -- ?
			c.global_x.increase
			print_line (global_x.value) -- ?
		end


feature -- Double example

	double (i: INTEGER): INTEGER
		require
			i > 0
		do -- once -- <<<<
			Result := i * 2
		ensure
			Result = i * 2
		end

	test_double
		do
			print_line (double (3)) -- ?
			print_line (double (7)) -- ?
			print_line (double (-3)) -- ?
		end


feature -- Recursive example

	recursive (x: INTEGER): INTEGER
		local
			l_recursive_result: INTEGER
		do -- once -- <<<<
			Result := 3
			if x > 1 then
				l_recursive_result := recursive (x - 1)
				Result := Result + l_recursive_result
			end
		end

	test_recursive
		do
			print_line (recursive (3)) -- ?
			print_line (recursive (7)) -- ?
			print_line (recursive (73)) -- ?
		end

feature -- GC example

	array: ARRAY [INTEGER]

	pointer_array: POINTER
		once
			create array.make_filled (0, 1, 10)
			Result := $array
		end

	pointer_collected: POINTER
		local
			c: COLLECTED
		once
			create c
			Result := $c
		end

	test_gc
		local
			a: ARRAY [INTEGER]
			i, j: INTEGER
		do
			print ("value collected pointer: ")
			print (pointer_collected)
			print ("%N")

			print ("value pointer: ")
			print (pointer_array)
			print (" - ")
			print ("address array: ")
			print ($array)
			print (" - ")
			print ("pointer=array: ")
			print (pointer_array ~ $array)
			print ("%N")

			from i := 1 until i > 10 loop
				create a.make_filled (1, 1, 1_048_576)
				i := i + 1
			end

			print ("value pointer: ")
			print (pointer_array)
			print (" - ")
			print ("address array: ")
			print ($array)
			print (" - ")
			print ("pointer=array: ")
			print (pointer_array ~ $array)
			print ("%N")

			print ("value collected pointer: ")
			print (pointer_collected)
			print ("%N")
		end


feature -- Helper

	print_line (a: ANY)
		do
			print (a)
			print ("%N")
		end

end
